﻿Option Explicit On

Public Class frmWGVII
    Shared Wert As Single

    Private Sub frmWGVII_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Ausgabe As String

        With Me
            .WindowState = 2
            .Text = "Programm  " + strPgmName + ", Version " + strVersion

            .GroupBox1.Text = "Einheiten "
            .GroupBox2.Text = "allgemeine Eingaben "
            .GroupBox3.Text = "Lagerung "
            .GroupBox4.Text = "Belastung "
            .GroupBox5.Text = "Ergebnisse "
            .GroupBox1.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .GroupBox2.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .GroupBox3.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .GroupBox4.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)
            .GroupBox5.Font = New Font("arial", 12, FontStyle.Bold, ForeColor = Color.Black)

            Call Vorbelegung()

            Ausgabe = "Beiwerte A, B und C sowie Festeinspannmomente für das" + vbCrLf
            Ausgabe = Ausgabe + "Weggrößenverfahren Theorie I. und II. Ordnung:" + vbCrLf
            Ausgabe = Ausgabe + "  1) Mi,k = ki,k*(A*phii + B*phik + C*psii,k) + M0i,k" + vbCrLf
            Ausgabe = Ausgabe + "  2) Mi,g = ki,g*(A*phii  + C*psii,g) + M0i,g" + vbCrLf
            .Label1.Text = Ausgabe
            .Label1.Font = New Font("arial", 12, FontStyle.Bold)

            'Einheiten
            .Label2.Text = "Länge"
            .Label3.Text = "Kraft"
            .TextBox1.Text = strEHL
            .TextBox2.Text = strEHF

            'allgemeine Eingaben
            .Label4.Text = "E-Modul [" + strEHF + "/" + strEHL + "²]"
            .TextBox3.Text = Format(EMod, "scientific")
            .Label5.Text = "Faktor für Schubverformungen [-]"
            .TextBox4.Text = Str(SchubF)
            .Label6.Text = "Längskraft N [" + strEHF + "]" + vbCrLf + "     (Druck < 0, Zug > 0: Theorie I.O.)"
            .TextBox5.Text = Str(N)
            .Label7.Text = "Stützweite L [" + strEHL + "]"
            .TextBox6.Text = Str(L)
            .Label8.Text = "Flächenmoment 2. Grades Iy [" + strEHL + "4]"
            .TextBox7.Text = Str(Iy)

            'Lagerung
            .RadioButton1.Text = " beidseitig eingespannt"
            .RadioButton2.Text = " einseitig  eingespannt"
            .RadioButton3.Text = " Kragarm               "
            If strLager = "1" Then .RadioButton1.Checked = True
            If strLager = "2" Then .RadioButton2.Checked = True
            If strLager = "3" Then .RadioButton3.Checked = True

            'Lastart
            .CheckBox1.Text = " Gleichlast/ Vorverformungen"
            .CheckBox2.Text = " Einzellast                 "
            .Label9.Text = "Gleichlast q [" + strEHF + "/" + strEHL + "²]"
            .Label10.Text = "Vorverformung e0 [" + strEHL + "]"
            .Label11.Text = "Einzellast F [" + strEHF + "]"
            .Label12.Text = "Abstand a [" + strEHL + "]"
            If strLastart = "1" Or strLastart = "3" Then
                .CheckBox1.Checked = True
                .TextBox8.Text = Str(q)
                .TextBox9.Text = Str(e0)
            Else
                .TextBox8.Text = ""
                .TextBox9.Text = ""
            End If
            If strLastart = "2" Or strLastart = "3" Then
                .CheckBox2.Checked = True
                .TextBox10.Text = Str(F)
                .TextBox11.Text = Str(a)
            Else
                .TextBox10.Text = ""
                .TextBox11.Text = ""
            End If

            'Ergebnisse
            .Label13.Text = "Beiwerte WGV"
            .Label14.Text = "Beiwerte WGV"
            .Label15.Text = "A = "
            .Label16.Text = "A = "
            .Label17.Text = "B = "
            .Label18.Text = "B = "
            .Label19.Text = "C = "
            .Label20.Text = "C = "
            .Label21.Text = "Mi = "
            .Label22.Text = "Mi = "
            .Label23.Text = "Mk = "
            .Label24.Text = "Mk = "
            .Label25.Text = "Festeinspannmomente"
            .Label26.Text = "Festeinspannmomente"
            .Label27.Text = "Theorie I. Ordnung"
            .Label28.Text = "Theorie II. Ordnung"
            .Label27.Font = New Font("arial", 14, FontStyle.Bold, ForeColor = Color.Red)
            .Label28.Font = New Font("arial", 14, FontStyle.Bold, ForeColor = Color.Red)
            .Label27.ForeColor = Color.Blue
            .Label28.ForeColor = Color.Blue
            .Label29.Text = "Knicklast (Obergrenze)"
        End With
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Berechnung
        Dim Ausgabe As String, AusgabeZ As String
        Call Hauptprogramm()
        With Me
            .Label15.Text = "A = " + Format(AQ1, "#0.0000")
            .Label16.Text = "A = " + Format(AQ, "#0.0000")
            .Label17.Text = "B = " + Format(BQ1, "#0.0000")
            .Label18.Text = "B = " + Format(BQ, "#0.0000")
            .Label19.Text = "C = " + Format(CQ1, "#0.0000")
            .Label20.Text = "C = " + Format(CQ, "#0.0000")
            .Label21.Text = "Mi = " + Format(SMi1, "#0.0000 ") + strEHF + strEHL
            .Label22.Text = "Mi = " + Format(SMi, "#0.0000 ") + strEHF + strEHL
            .Label23.Text = "Mk = " + Format(SMk1, "#0.0000 ") + strEHF + strEHL
            .Label24.Text = "Mk = " + Format(SMk, "#0.0000 ") + strEHF + strEHL
            Ausgabe = "Knicklast (Obergrenze)  NKi = " + Format(NKi, "0 ") + strEHF
            If NKi < -N Then
                Ausgabe = Ausgabe + " < "
                AusgabeZ = vbCrLf + "Die Obergrenze der Knicklast wird überschritten!"
                .Label29.ForeColor = Color.Red
            Else
                Ausgabe = Ausgabe + " > "
                AusgabeZ = ""
                .Label29.ForeColor = Color.Blue
            End If
            .Label29.Text = Ausgabe + Format(Math.Abs(N), "0 ") + strEHF + " = N" + AusgabeZ
        End With
    End Sub

    Public Sub textbox1_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.Leave
        'Einheit Länge
        strEHL = TextBox1.Text
    End Sub

    Public Sub textbox2_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox2.Leave
        'Einheit Länge
        strEHF = TextBox2.Text
    End Sub

    Private Sub textbox3_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox3.Leave
        'E-Modul
        Call EingPr(TextBox3.Text)
        EMod = Wert1
    End Sub

    Private Sub textbox4_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox4.Leave
        'Faktor Schubverformungen
        Call EingPr(TextBox4.Text)
        SchubF = Wert1
    End Sub

    Private Sub textbox5_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox5.Leave
        'Längskraft
        Call EingPr(TextBox5.Text)
        N = Wert1
    End Sub

    Private Sub textbox6_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox6.Leave
        'Stützweite
        Call EingPr(TextBox6.Text)
        L = Wert1
    End Sub

    Private Sub textbox7_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox7.Leave
        'Flächenmoment 2. Grades
        Call EingPr(TextBox7.Text)
        Iy = Wert1
    End Sub

    Private Sub textbox8_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox8.Leave
        'Gleichlast
        Call EingPr(TextBox8.Text)
        q = Wert1
    End Sub

    Private Sub textbox9_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox9.Leave
        'Vorverformung
        Call EingPr(TextBox9.Text)
        e0 = Wert1
    End Sub

    Private Sub textbox10_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox10.Leave
        'Einzellast
        Call EingPr(TextBox10.Text)
        F = Wert1
    End Sub

    Private Sub textbox11_leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox11.Leave
        'Abstand der Einzellast
        Call EingPr(TextBox11.Text)
        a = Wert1
        If a > L Then
            MsgBox("unzulässige Eingabe")
            a = L
            TextBox11.Text = Str(a)
        End If
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        'beidseitig eingespannt
        strLager = "1"
    End Sub

    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        'einzeitig eingespannt, gelenkig
        strLager = "2"
    End Sub

    Private Sub RadioButton3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton3.CheckedChanged
        'Kragarm
        strLager = "3"
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        'Gleichlast, Vorverformung
        strLastart = "1"
        With Me
            If .CheckBox2.Checked = True Then
                strLastart = "3"
            Else
                F = 0
                a = 0
            End If
            If .CheckBox1.Checked = False Then
                strLastart = "2"
                q = 0
                e0 = 0
            End If
            .TextBox8.Text = Str(q)
            .TextBox9.Text = Str(e0)
            .TextBox10.Text = Str(F)
            .TextBox11.Text = Str(a)
        End With
    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        'Einzellast
        strLastart = "2"
        With Me
            If .CheckBox1.Checked Then
                strLastart = "3"
            Else
                q = 0
                e0 = 0
            End If
            If .CheckBox2.Checked = False Then
                strLastart = "1"
                F = 0
                a = 0
            End If
            .TextBox8.Text = Str(q)
            .TextBox9.Text = Str(e0)
            .TextBox10.Text = Str(F)
            .TextBox11.Text = Str(a)
        End With
    End Sub

    Public Sub EingPr(ByVal Eing1 As String)
        'Eingabeprüfung
        Dim Stelle As Integer
        On Error GoTo ErrEingabe
        Stelle = InStr(Eing1, ",")
        If Stelle > 0 Then
            Mid(Eing1, Stelle, 1) = "."
        End If
        If Eing1 = "" Then Eing1 = "0"
        Wert1 = Val(Eing1)
        Exit Sub

ErrEingabe:
        MsgBox("fehlerhafte Eingabe")
    End Sub
End Class
